<?php
/* vim: set expandtab sw=4 ts=4 sts=4: */
/**
 * Set of functions used with the relation and pdf feature
 *
 * @version $Id$
 * @package phpMyAdmin
 */
if (! defined('PHPMYADMIN')) {
    exit;
}

/**
 *
 */
require_once './libraries/Table.class.php';

/**
 * Executes a query as controluser if possible, otherwise as normal user
 *
 * @param   string    the query to execute
 * @param   boolean   whether to display SQL error messages or not
 *
 * @return  integer   the result set, or false if no result set
 *
 * @access  public
 *
 * @author  Mike Beck <mikebeck@users.sourceforge.net>
 */
function _QO86Q($_QtJ8O, $_IQoI6 = true, $_QCiC0 = 0)
{
    if ($_IQoI6) {
        $_QOOCt = PMA_DBI_query($_QtJ8O, $GLOBALS["_IQt1I"], $_QCiC0);
    } else {
        $_QOOCt = @PMA_DBI_try_query($_QtJ8O, $GLOBALS["_IQt1I"], $_QCiC0);
    } // end if... else...

    if ($_QOOCt) {
        return $_QOOCt;
    } else {
        return false;
    }
} // end of the "_QO86Q()" function

/**
 * @uses    $_SESSION["_IQCCt"][$GLOBALS["_IQ01t"]] for caching
 * @uses    $GLOBALS["_IQijI"] to set it
 * @uses    $GLOBALS["_IQ01t"] to ensure we are using server-specific pmadb
 * @uses    _QOB1E()
 * @uses    _QOP8O()
 * @param   bool    $_IQC0t    whether to print diagnostic info
 * @return  array   $_IQijI
 */
function _QO8P6($_IQC0t = false)
{
    if (empty($_SESSION["_IQCCt"][$GLOBALS["_IQ01t"]])) {
        $_SESSION["_IQCCt"][$GLOBALS["_IQ01t"]] = _QOB1E();
    }

    // just for BC but needs to be before _QOP8O()
    // which uses it
    $GLOBALS["_IQijI"] = $_SESSION["_IQCCt"][$GLOBALS["_IQ01t"]];

    if ($_IQC0t) {
        _QOP8O($_SESSION["_IQCCt"][$GLOBALS["_IQ01t"]]);
    }

    return $_SESSION["_IQCCt"][$GLOBALS["_IQ01t"]];
}

/**
 * prints out diagnostic info for pma relation feature
 *
 * @uses    $GLOBALS["_IQ01t"]
 * @uses    $GLOBALS["_IQt1I"]
 * @uses    $GLOBALS["_IQLI1"]
 * @uses    $GLOBALS["_IQLl8"]
 * @uses    $GLOBALS["_II0ol"]
 * @uses    $GLOBALS["_II00l"]
 * @uses    $GLOBALS["_IQlCQ"]
 * @uses    $GLOBALS['strDisplayFeat']
 * @uses    $GLOBALS['strCreatePdfFeat']
 * @uses    $GLOBALS['strColComFeat']
 * @uses    $GLOBALS['strBookmarkQuery']
 * @uses    $GLOBALS["_II1QC"]
 * @uses    $GLOBALS['strQuerySQLHistory']
 * @uses    $GLOBALS['strDesigner']
 * @uses    $_I0l11['Server']['pmadb']
 * @uses    sprintf()
 * @uses    _QOPFL()
 * @uses    _QOAOL()
 * @param   array   $_IQijI
 */
function _QOP8O($_IQijI)
{
    $_IQLQf['error'] = '<font color="red"><strong>' . $GLOBALS["_IQLI1"]
                   . '</strong></font> [ <a href="Documentation.html#%s" target="documentation">'
                   . $GLOBALS["_IQLl8"] . '</a> ]';

    $_IQLQf['ok'] = '<font color="green"><strong>' . $GLOBALS["_IQl10"] . '</strong></font>';
    $_IQLQf['enabled']  = '<font color="green">' . $GLOBALS["_IQlCQ"] . '</font>';
    $_IQLQf['disabled'] = '<font color="red">'   . $GLOBALS["_II00l"] . '</font>';

    if (false === $GLOBALS["_I0l11"]['Server']['pmadb']) {
        echo 'PMA Database ... '
             . sprintf($_IQLQf['error'], 'pmadb')
             . '<br />' . "\n"
             . $GLOBALS["_II0ol"]
             . ' <font color="green">' . $GLOBALS["_II00l"]
             . '</font>' . "\n";
        return;
    }

    echo '<table>' . "\n";

    _QOAOL('pmadb', $GLOBALS["_I0l11"]['Server']['pmadb'], $_IQLQf, 'pmadb');

    _QOAOL('relation', isset($_IQijI['relation']), $_IQLQf, 'relation');

    _QOPFL('strGeneralRelationFeat', 'relwork', $_IQLQf);

    _QOAOL('table_info', isset($_IQijI['table_info']), $_IQLQf, 'table_info');

    _QOPFL('strDisplayFeat', 'displaywork', $_IQLQf);

    _QOAOL('table_coords', isset($_IQijI['table_coords']), $_IQLQf, 'table_coords');

    _QOAOL('pdf_pages', isset($_IQijI['pdf_pages']), $_IQLQf, 'table_coords');

    _QOPFL('strCreatePdfFeat', 'pdfwork', $_IQLQf);

    _QOAOL('column_info', isset($_IQijI['column_info']), $_IQLQf, 'col_com');

    _QOPFL('strColComFeat', 'commwork', $_IQLQf, false);

    _QOPFL('strMIME_transformation', 'mimework', $_IQLQf);

    if ($_IQijI['commwork'] && ! $_IQijI['mimework']) {
        echo '<tr><td colspan=2 align="left">' . $GLOBALS["_II1QC"] . '</td></tr>' . "\n";
    }

    _QOAOL('bookmarktable', isset($_IQijI['bookmark']), $_IQLQf, 'bookmark');

    _QOPFL('strBookmarkQuery', 'bookmarkwork', $_IQLQf);

    _QOAOL('history', isset($_IQijI['history']), $_IQLQf, 'history');

    _QOPFL('strQuerySQLHistory', 'historywork', $_IQLQf);

    _QOAOL('designer_coords', isset($_IQijI['designer_coords']), $_IQLQf, 'designer_coords');

    _QOPFL('strDesigner', 'designerwork', $_IQLQf);

    _QOAOL('tracking', isset($_IQijI['tracking']), $_IQLQf, 'tracking');

    _QOPFL('strTracking', 'trackingwork', $_IQLQf);

    echo '</table>' . "\n";
}

/**
 * prints out one diagnostic message for a feature
 *
 * @param   string  feature name in a message string
 * @param   string  the $GLOBALS["_IQijI"] parameter to check
 * @param   array   utility messages
 * @param   boolean whether to skip a line after the message
 */
function _QOPFL($_II1if, $_IIQJI, $_IQLQf, $_IIIjC=true)
{
    echo '    <tr><td colspan=2 align="right">' . $GLOBALS[$_II1if] . ': '
         . ($GLOBALS["_IQijI"][$_IIQJI] ? $_IQLQf['enabled'] : $_IQLQf['disabled'])
         . '</td></tr>' . "\n";
    if ($_IIIjC) {
        echo '    <tr><td>&nbsp;</td></tr>' . "\n";
    }
}

/**
 * prints out one diagnostic message for a configuration parameter
 *
 * @param   string  config parameter name to display
 * @param   boolean whether this parameter is set
 * @param   array   utility messages
 * @param   string  anchor in Documentation.html
 */
function _QOAOL($_IIIiJ, $_IIj8O, $_IQLQf, $_IIJIi)
{
    echo '    <tr><th align="left">';
    echo '$_I0l11[\'Servers\'][$_Qt6If][\'' . $_IIIiJ . '\']  ... </th><td align="right">';
    echo ($_IIj8O ? $_IQLQf['ok'] : sprintf($_IQLQf['error'], $_IIJIi)) . '</td></tr>' . "\n";
}


/**
 * Defines the relation parameters for the current user
 * just a copy of the functions used for relations ;-)
 * but added some stuff to check what will work
 *
 * @uses    $_I0l11['Server']['user']
 * @uses    $_I0l11['Server']['pmadb']
 * @uses    $_I0l11['Server']['verbose_check']
 * @uses    $GLOBALS["_IQ01t"]
 * @uses    $GLOBALS["_IQt1I"]
 * @uses    PMA_DBI_QUERY_STORE
 * @uses    PMA_DBI_select_db()
 * @uses    PMA_backquote()
 * @uses    _QO86Q()
 * @uses    PMA_DBI_fetch_row()
 * @uses    PMA_DBI_free_result()
 * @access  protected
 * @author  Mike Beck <mikebeck@users.sourceforge.net>
 * @return  array    the relation parameters for the current user
 */
function _QOB1E()
{
    $_IQijI                = array();
    $_IQijI['relwork']     = false;
    $_IQijI['displaywork'] = false;
    $_IQijI['bookmarkwork']= false;
    $_IQijI['pdfwork']     = false;
    $_IQijI['commwork']    = false;
    $_IQijI['mimework']    = false;
    $_IQijI['historywork'] = false;
    $_IQijI['trackingwork'] = false;
    $_IQijI['designerwork'] = false;
    $_IQijI['allworks']    = false;
    $_IQijI['user']        = null;
    $_IQijI['db']          = null;

    if ($GLOBALS["_IQ01t"] == 0 || empty($GLOBALS["_I0l11"]['Server']['pmadb'])
     || ! PMA_DBI_select_db($GLOBALS["_I0l11"]['Server']['pmadb'], $GLOBALS["_IQt1I"])) {
        // No server selected -> no bookmark table
        // we return the array with the falses in it,
        // to avoid some 'Unitialized string offset' errors later
        $GLOBALS["_I0l11"]['Server']['pmadb'] = false;
        return $_IQijI;
    }


    $_IQijI['user']  = $GLOBALS["_I0l11"]['Server']['user'];
    $_IQijI['db']    = $GLOBALS["_I0l11"]['Server']['pmadb'];

    //  Now I just check if all tables that i need are present so I can for
    //  example enable relations but not pdf...
    //  I was thinking of checking if they have all required columns but I
    //  fear it might be too slow

    $_II6I8 = 'SHOW TABLES FROM ' . PMA_backquote($GLOBALS["_I0l11"]['Server']['pmadb']);
    $_II6lt    = _QO86Q($_II6I8, false, PMA_DBI_QUERY_STORE);

    if (! $_II6lt) {
        // query failed ... ?
        //$GLOBALS["_I0l11"]['Server']['pmadb'] = false;
        return $_IQijI;
    }

    while ($_IIfJj = @PMA_DBI_fetch_row($_II6lt)) {
        if ($_IIfJj[0] == $GLOBALS["_I0l11"]['Server']['bookmarktable']) {
            $_IQijI['bookmark']        = $_IIfJj[0];
        } elseif ($_IIfJj[0] == $GLOBALS["_I0l11"]['Server']['relation']) {
            $_IQijI['relation']        = $_IIfJj[0];
        } elseif ($_IIfJj[0] == $GLOBALS["_I0l11"]['Server']['table_info']) {
            $_IQijI['table_info']      = $_IIfJj[0];
        } elseif ($_IIfJj[0] == $GLOBALS["_I0l11"]['Server']['table_coords']) {
            $_IQijI['table_coords']    = $_IIfJj[0];
        } elseif ($_IIfJj[0] == $GLOBALS["_I0l11"]['Server']['designer_coords']) {
            $_IQijI['designer_coords']    = $_IIfJj[0];
        } elseif ($_IIfJj[0] == $GLOBALS["_I0l11"]['Server']['column_info']) {
            $_IQijI['column_info'] = $_IIfJj[0];
        } elseif ($_IIfJj[0] == $GLOBALS["_I0l11"]['Server']['pdf_pages']) {
            $_IQijI['pdf_pages']       = $_IIfJj[0];
        } elseif ($_IIfJj[0] == $GLOBALS["_I0l11"]['Server']['history']) {
            $_IQijI['history'] = $_IIfJj[0];
        } elseif ($_IIfJj[0] == $GLOBALS["_I0l11"]['Server']['tracking']) {
            $_IQijI['tracking'] = $_IIfJj[0];
        }
    } // end while
    PMA_DBI_free_result($_II6lt);

    if (isset($_IQijI['relation'])) {
        $_IQijI['relwork']         = true;
        if (isset($_IQijI['table_info'])) {
                $_IQijI['displaywork'] = true;
        }
    }
    if (isset($_IQijI['table_coords']) && isset($_IQijI['pdf_pages'])) {
        $_IQijI['pdfwork']     = true;
    }
    if (isset($_IQijI['column_info'])) {
        $_IQijI['commwork']    = true;

        if ($GLOBALS["_I0l11"]['Server']['verbose_check']) {
            $_II8I8  = 'SHOW FIELDS FROM '
                . PMA_backquote($_IQijI['db']) . '.'
                . PMA_backquote($_IQijI['column_info']);
            $_II8ot     = _QO86Q($_II8I8, false);

            $_II8LL                = false;
            $_IIttt          = false;
            $_IIti0  = false;
            while ($_IIOIJ = @PMA_DBI_fetch_row($_II8ot)) {
                if ($_IIOIJ[0] == 'mimetype') {
                    $_II8LL               = true;
                } elseif ($_IIOIJ[0] == 'transformation') {
                    $_IIttt         = true;
                } elseif ($_IIOIJ[0] == 'transformation_options') {
                    $_IIti0 = true;
                }
            }
            PMA_DBI_free_result($_II8ot);

            if ($_II8LL
             && $_IIttt
             && $_IIti0) {
                $_IQijI['mimework'] = true;
            }
        } else {
            $_IQijI['mimework'] = true;
        }
    }

    if (isset($_IQijI['history'])) {
        $_IQijI['historywork']     = true;
    }

    if (isset($_IQijI['tracking'])) {
        $_IQijI['trackingwork']     = true;
    }

    // we do not absolutely need that the internal relations or the PDF
    // schema feature be activated
    if (isset($_IQijI['designer_coords'])) {
        $_IQijI['designerwork']     = true;
    }

    if (isset($_IQijI['bookmark'])) {
        $_IQijI['bookmarkwork']     = true;
    }

    if ($_IQijI['relwork'] && $_IQijI['displaywork']
     && $_IQijI['pdfwork'] && $_IQijI['commwork']
     && $_IQijI['mimework'] && $_IQijI['historywork']
     && $_IQijI['trackingwork']
     && $_IQijI['bookmarkwork'] && $_IQijI['designerwork']) {
        $_IQijI['allworks'] = true;
    }

    return $_IQijI;
} // end of the '_QO8P6()' function

/**
 * Gets all Relations to foreign tables for a given table or
 * optionally a given column in a table
 *
 * @author  Mike Beck <mikebeck@users.sourceforge.net>
 * @author  Marc Delisle
 * @access  public
 * @uses    $GLOBALS["_IQt1I"]
 * @uses    $GLOBALS["_IILJ1"]
 * @uses    _QO8P6()
 * @uses    PMA_backquote()
 * @uses    PMA_sqlAddslashes()
 * @uses    PMA_DBI_fetch_result()
 * @uses    PMA_DBI_fetch_value()
 * @uses    PMA_SQP_analyze()
 * @uses    PMA_SQP_parse()
 * @uses    count()
 * @uses    strlen()
 * @param   string   $_I1too        the name of the db to check for
 * @param   string   $_QtoOL     the name of the table to check for
 * @param   string   $_IIO6O    the name of the column to check for
 * @param   string   $_IIOCJ    the source for foreign key information
 * @return  array    db,table,column
 */
function _QOBA0($_I1too, $_QtoOL, $_IIO6O = '', $_IIOCJ = 'both')
{
    $_IQijI = _QO8P6();
    $_IIo6f = array();

    if ($_IQijI['relwork'] && ($_IIOCJ == 'both' || $_IIOCJ == 'internal')) {
        $_IIotl = '
             SELECT `master_field`,
                    `foreign_db`,
                    `foreign_table`,
                    `foreign_field`
               FROM ' . PMA_backquote($_IQijI['db']) . '.' . PMA_backquote($_IQijI['relation']) . '
              WHERE `master_db`    = \'' . PMA_sqlAddslashes($_I1too) . '\'
                AND `master_table` = \'' . PMA_sqlAddslashes($_QtoOL) . '\' ';
        if (strlen($_IIO6O)) {
            $_IIotl .= ' AND `master_field` = \'' . PMA_sqlAddslashes($_IIO6O) . '\'';
        }
        $_IIo6f = PMA_DBI_fetch_result($_IIotl, 'master_field', null, $GLOBALS["_IQt1I"]);
    }

    if (($_IIOCJ == 'both' || $_IIOCJ == 'foreign') && strlen($_QtoOL)) {
        $_IIoOC = 'SHOW CREATE TABLE '
            . PMA_backquote($_I1too) . '.' . PMA_backquote($_QtoOL);
        $_IICtQ = PMA_DBI_fetch_value($_IIoOC, 0, 1);
        $_IIClo = PMA_SQP_analyze(PMA_SQP_parse($_IICtQ));

        foreach ($_IIClo[0]['foreign_keys'] as $_IIiJt) {
            // The analyzer may return more than one column name in the
            // index list or the ref_index_list; if this happens,
            // the current logic just discards the whole index; having
            // more than one index field is currently unsupported (see FAQ 3.6)
            if (count($_IIiJt['index_list']) == 1) {
                foreach ($_IIiJt['index_list'] as $_Qt6If => $_Qo0Jl) {
                    // If a foreign key is defined in the 'internal' source (pmadb)
                    // and as a native foreign key, we won't get it twice
                    // if $_IIOCJ='both' because we use $_Qo0Jl as key

                    // The parser looks for a CONSTRAINT clause just before
                    // the FOREIGN KEY clause. It finds it (as output from
                    // SHOW CREATE TABLE) in MySQL 4.0.13, but not in older
                    // versions like 3.23.58.
                    // In those cases, the FOREIGN KEY parsing will put numbers
                    // like -1, 0, 1... instead of the constraint number.

                    if (isset($_IIiJt['constraint'])) {
                        $_IIo6f[$_Qo0Jl]['constraint'] = $_IIiJt['constraint'];
                    }

                    if (isset($_IIiJt['ref_db_name'])) {
                        $_IIo6f[$_Qo0Jl]['foreign_db'] = $_IIiJt['ref_db_name'];
                    } else {
                        $_IIo6f[$_Qo0Jl]['foreign_db'] = $_I1too;
                    }
                    $_IIo6f[$_Qo0Jl]['foreign_table'] = $_IIiJt['ref_table_name'];
                    $_IIo6f[$_Qo0Jl]['foreign_field'] = $_IIiJt['ref_index_list'][$_Qt6If];
                    if (isset($_IIiJt['on_delete'])) {
                        $_IIo6f[$_Qo0Jl]['on_delete'] = $_IIiJt['on_delete'];
                    }
                    if (isset($_IIiJt['on_update'])) {
                        $_IIo6f[$_Qo0Jl]['on_update'] = $_IIiJt['on_update'];
                    }
                }
            }
        }
    }

    /**
     * Emulating relations for some information_schema tables
     */
    if ($_I1too == 'information_schema'
     && ($_IIOCJ == 'internal' || $_IIOCJ == 'both')) {
        require_once './libraries/information_schema_relations.lib.php';

        if (isset($GLOBALS["_IILJ1"][$_QtoOL])) {
            foreach ($GLOBALS["_IILJ1"][$_QtoOL] as $_Qo0Jl => $_IILLi) {
                if ((! strlen($_IIO6O) || $_IIO6O == $_Qo0Jl)
                 && (! isset($_IIo6f[$_Qo0Jl]) || ! strlen($_IIo6f[$_Qo0Jl]))) {
                    $_IIo6f[$_Qo0Jl] = $_IILLi;
                }
            }
        }
    }

    return $_IIo6f;
} // end of the '_QOBA0()' function

/**
 * Gets the display field of a table
 *
 * @access  public
 * @author  Mike Beck <mikebeck@users.sourceforge.net>
 * @uses    $GLOBALS["_IQt1I"]
 * @uses    _QO8P6()
 * @uses    PMA_backquote()
 * @uses    PMA_sqlAddslashes()
 * @uses    PMA_DBI_fetch_single_row()
 * @uses    trim()
 * @param   string   $_I1too    the name of the db to check for
 * @param   string   $_QtoOL the name of the table to check for
 * @return  string   field name
 */
function _QOCRC($_I1too, $_QtoOL)
{
    $_IQijI = _QO8P6();

    /**
     * Try to fetch the display field from DB.
     */
    if ($_IQijI['displaywork']) {
        $_IIlJ0 = '
             SELECT `display_field`
               FROM ' . PMA_backquote($_IQijI['db']) . '.' . PMA_backquote($_IQijI['table_info']) . '
              WHERE `db_name`    = \'' . PMA_sqlAddslashes($_I1too) . '\'
                AND `table_name` = \'' . PMA_sqlAddslashes($_QtoOL) . '\'';

        $_QOJCl = PMA_DBI_fetch_single_row($_IIlJ0, 'ASSOC', $GLOBALS["_IQt1I"]);
        if (isset($_QOJCl['display_field'])) {
            return $_QOJCl['display_field'];
        }
    }

    /**
     * Emulating the display field for some information_schema tables.
     */
    if ($_I1too == 'information_schema') {
        switch ($_QtoOL) {
            case 'CHARACTER_SETS': return 'DESCRIPTION';
            case 'TABLES':         return 'TABLE_COMMENT';
        }
    }

    /**
     * No Luck...
     */
    return false;

} // end of the '_QOCRC()' function

/**
 * Gets the comments for all rows of a table or the db itself
 *
 * @author  Mike Beck <mikebeck@users.sourceforge.net>
 * @author  lem9
 * @access  public
 * @uses    PMA_DBI_get_fields()
 * @uses    _QOD81()
 * @param   string   the name of the db to check for
 * @param   string   the name of the table to check for
 * @return  array    [field_name] = comment
 */
function _QOC8P($_I1too, $_QtoOL = '')
{
    $_IIl88 = array();

    if ($_QtoOL != '') {
        // MySQL native column comments
        $_IIlLo = PMA_DBI_get_fields($_I1too, $_QtoOL);
        if ($_IIlLo) {
            foreach ($_IIlLo as $_QClCI => $_Qo0Jl) {
                if (! empty($_Qo0Jl['Comment'])) {
                    $_IIl88[$_Qo0Jl['Field']] = $_Qo0Jl['Comment'];
                }
            }
        }
    } else {
        $_IIl88[] = _QOD81($_I1too);
    }

    return $_IIl88;
} // end of the '_QOC8P()' function

/**
 * Gets the comment for a db
 *
 * @author  Mike Beck <mikebeck@users.sourceforge.net>
 * @author  lem9
 * @access  public
 * @uses    PMA_DBI_QUERY_STORE
 * @uses    PMA_DBI_num_rows()
 * @uses    PMA_DBI_fetch_assoc()
 * @uses    PMA_DBI_free_result()
 * @uses    _QO8P6()
 * @uses    PMA_backquote()
 * @uses    PMA_sqlAddslashes()
 * @uses    _QO86Q()
 * @uses    strlen()
 * @param   string   the name of the db to check for
 * @return  string   comment
 */
function _QOD81($_I1too)
{
    $_IQijI = _QO8P6();
    $_Ij0iQ = '';

    if ($_IQijI['commwork']) {
        // pmadb internal db comment
        $_Ij11f = "
             SELECT `comment`
               FROM " . PMA_backquote($_IQijI['db']) . "." . PMA_backquote($_IQijI['column_info']) . "
              WHERE db_name     = '" . PMA_sqlAddslashes($_I1too) . "'
                AND table_name  = ''
                AND column_name = '(db_comment)'";
        $_Ij1jt = _QO86Q($_Ij11f, true, PMA_DBI_QUERY_STORE);

        if ($_Ij1jt && PMA_DBI_num_rows($_Ij1jt) > 0) {
            $_QOJCl = PMA_DBI_fetch_assoc($_Ij1jt);
            $_Ij0iQ = $_QOJCl['comment'];
        }
        PMA_DBI_free_result($_Ij1jt);
    }

    return $_Ij0iQ;
} // end of the '_QOD81()' function

/**
 * Gets the comment for a db
 *
 * @author  Mike Beck <mikebeck@users.sourceforge.net>
 * @author  lem9
 * @access  public
 * @uses    PMA_DBI_QUERY_STORE
 * @uses    PMA_DBI_num_rows()
 * @uses    PMA_DBI_fetch_assoc()
 * @uses    PMA_DBI_free_result()
 * @uses    _QO8P6()
 * @uses    PMA_backquote()
 * @uses    PMA_sqlAddslashes()
 * @uses    _QO86Q()
 * @uses    strlen()
 * @param   string   the name of the db to check for
 * @return  string   comment
 */
function _QOEOA()
{
    $_IQijI = _QO8P6();
    $_IIl88 = array();

    if ($_IQijI['commwork']) {
        // pmadb internal db comment
        $_Ij11f = "
             SELECT `db_name`, `comment`
               FROM " . PMA_backquote($_IQijI['db']) . "." . PMA_backquote($_IQijI['column_info']) . "
              WHERE `column_name` = '(db_comment)'";
        $_Ij1jt = _QO86Q($_Ij11f, true, PMA_DBI_QUERY_STORE);

        if ($_Ij1jt && PMA_DBI_num_rows($_Ij1jt) > 0) {
            while ($_QOJCl = PMA_DBI_fetch_assoc($_Ij1jt)) {
                $_IIl88[$_QOJCl['db_name']] = $_QOJCl['comment'];
            }
        }
        PMA_DBI_free_result($_Ij1jt);
    }

    return $_IIl88;
} // end of the '_QOEOA()' function

/**
 * Set a database comment to a certain value.
 *
 * @uses    _QO8P6()
 * @uses    PMA_backquote()
 * @uses    PMA_sqlAddslashes()
 * @uses    _QO86Q()
 * @uses    strlen()
 * @access  public
 * @param   string   $_I1too        the name of the db
 * @param   string   $_Ij0iQ   the value of the column
 * @return  boolean  true, if comment-query was made.
 */
function _QOEE1($_I1too, $_Ij0iQ = '')
{
    $_IQijI = _QO8P6();

    if (! $_IQijI['commwork']) {
        return false;
    }

    if (strlen($_Ij0iQ)) {
        $_Ij1Lf = "
             INSERT INTO
                    " . PMA_backquote($_IQijI['db']) . "." . PMA_backquote($_IQijI['column_info']) . "
                    (`db_name`, `table_name`, `column_name`, `comment`)
             VALUES (
                   '" . PMA_sqlAddslashes($_I1too) . "',
                   '',
                   '(db_comment)',
                   '" . PMA_sqlAddslashes($_Ij0iQ) . "')
             ON DUPLICATE KEY UPDATE
                `comment` = '" . PMA_sqlAddslashes($_Ij0iQ) . "'";
    } else {
        $_Ij1Lf = '
             DELETE FROM
                    ' . PMA_backquote($_IQijI['db']) . '.' . PMA_backquote($_IQijI['column_info']) . '
              WHERE `db_name`     = \'' . PMA_sqlAddslashes($_I1too) . '\'
                AND `table_name`  = \'\'
                AND `column_name` = \'(db_comment)\'';
    }

    if (isset($_Ij1Lf)){
        return _QO86Q($_Ij1Lf);
    }

    return false;
} // end of '_QOEE1()' function

/**
 * Set a SQL history entry
 *
 * @uses    $_SESSION["_IjQfI"]
 * @uses    $_I0l11['QueryHistoryDB']
 * @uses    $_I0l11['QueryHistoryMax']
 * @uses    _QO8P6()
 * @uses    _QO86Q()
 * @uses    PMA_backquote()
 * @uses    PMA_sqlAddslashes()
 * @uses    count()
 * @uses    md5()
 * @uses    array_shift()
 * @param   string   $_I1too        the name of the db
 * @param   string   $_QtoOL     the name of the table
 * @param   string   $username  the username
 * @param   string   $_IjQQ6  the sql query
 * @access  public
 */
function _QOFD1($_I1too, $_QtoOL, $username, $_IjQQ6)
{
    if (strlen($_IjQQ6) > $GLOBALS["_I0l11"]['MaxCharactersInDisplayedSQL']) {
        return;
    }

    $_IQijI = _QO8P6();

    if (! isset($_SESSION["_IjQfI"])) {
        $_SESSION["_IjQfI"] = array();
    }

    $_QClCI = md5($_IjQQ6 . $_I1too . $_QtoOL);

    if (isset($_SESSION["_IjQfI"][$_QClCI])) {
        unset($_SESSION["_IjQfI"][$_QClCI]);
    }

    $_SESSION["_IjQfI"][$_QClCI] = array(
        'db' => $_I1too,
        'table' => $_QtoOL,
        'sqlquery' => $_IjQQ6,
    );

    if (count($_SESSION["_IjQfI"]) > $GLOBALS["_I0l11"]['QueryHistoryMax']) {
        // history should not exceed a maximum count
        array_shift($_SESSION["_IjQfI"]);
    }

    if (! $_IQijI['historywork'] || ! $GLOBALS["_I0l11"]['QueryHistoryDB']) {
        return;
    }

    _QO86Q('
         INSERT INTO
                ' . PMA_backquote($_IQijI['db']) . '.' . PMA_backquote($_IQijI['history']) . '
              (`username`,
                `db`,
                `table`,
                `timevalue`,
                `sqlquery`)
         VALUES
              (\'' . PMA_sqlAddslashes($username) . '\',
               \'' . PMA_sqlAddslashes($_I1too) . '\',
               \'' . PMA_sqlAddslashes($_QtoOL) . '\',
               NOW(),
               \'' . PMA_sqlAddslashes($_IjQQ6) . '\')');
} // end of '_QOFD1()' function

/**
 * Gets a SQL history entry
 *
 * @uses    $_SESSION["_IjQfI"]
 * @uses    $GLOBALS["_IQt1I"]
 * @uses    _QO8P6()
 * @uses    PMA_backquote()
 * @uses    PMA_sqlAddslashes()
 * @uses    PMA_DBI_fetch_result()
 * @uses    array_reverse()
 * @param   string   $username  the username
 * @return  array    list of history items
 * @access  public
 */
function _QL06O($username)
{
    $_IQijI = _QO8P6();

    if (isset($_SESSION["_IjQfI"])) {
        return array_reverse($_SESSION["_IjQfI"]);
    }

    if (! $_IQijI['historywork']) {
        return false;
    }

    $_IjIjo = '
         SELECT `db`,
                `table`,
                `sqlquery`
           FROM ' . PMA_backquote($_IQijI['db']) . '.' . PMA_backquote($_IQijI['history']) . '
          WHERE `username` = \'' . PMA_sqlAddslashes($username) . '\'
       ORDER BY `id` DESC';

    return PMA_DBI_fetch_result($_IjIjo, null, null, $GLOBALS["_IQt1I"]);
} // end of '_QL06O()' function

/**
 * purges SQL history
 *
 * deletes entries that exceeds $_I0l11['QueryHistoryMax'], oldest first, for the
 * given user
 *
 * @uses    $_I0l11['QueryHistoryMax']
 * @uses    $_I0l11['QueryHistoryDB']
 * @uses    $GLOBALS["_IQt1I"]
 * @uses    PMA_backquote()
 * @uses    PMA_sqlAddSlashes()
 * @uses    _QO86Q()
 * @uses    PMA_DBI_fetch_value()
 * @param   string   $username  the username
 * @access  public
 */
function _QL08Q($username)
{
    $_IQijI = _QO8P6();
    if (! $GLOBALS["_I0l11"]['QueryHistoryDB'] || ! $_IQijI['historywork']) {
        return;
    }

    if (! $_IQijI['historywork']) {
        return;
    }

    $_Ijj0O = '
         SELECT `timevalue`
           FROM ' . PMA_backquote($_IQijI['db']) . '.' . PMA_backquote($_IQijI['history']) . '
          WHERE `username` = \'' . PMA_sqlAddSlashes($username) . '\'
       ORDER BY `timevalue` DESC
          LIMIT ' . $GLOBALS["_I0l11"]['QueryHistoryMax'] . ', 1';

    if ($_Ijj8l = PMA_DBI_fetch_value($_Ijj0O, 0, 0, $GLOBALS["_IQt1I"])) {
        _QO86Q('
             DELETE FROM
                    ' . PMA_backquote($_IQijI['db']) . '.' . PMA_backquote($_IQijI['history']) . '
              WHERE `username` = \'' . PMA_sqlAddSlashes($username) . '\'
                AND `timevalue` <= \'' . $_Ijj8l . '\'');
    }
} // end of '_QL08Q()' function

/**
 * Prepares the dropdown for one mode
 *
 * @uses    $_I0l11['LimitChars']
 * @uses    $_I0l11['NaturalOrder']
 * @uses    PMA_strlen()
 * @uses    htmlspecialchars()
 * @uses    substr()
 * @uses    uksort()
 * @uses    ksort()
 * @uses    natcasesort()
 * @uses    asort()
 * @param   array    $_IIo6f   the keys and values for foreigns
 * @param   string   $_Ijjt6      the current data of the dropdown
 * @param   string   $_IjjLQ      the needed mode
 *
 * @return  array   the <option value=""><option>s
 *
 * @access  protected
 */
function _QL0PA($_IIo6f, $_Ijjt6, $_IjjLQ)
{
    $_IjJIj = array();

    if ($_IjjLQ == 'id-content') {
        // sort for id-content
        if ($GLOBALS["_I0l11"]['NaturalOrder']) {
            uksort($_IIo6f, 'strnatcasecmp');
        } else {
            ksort($_IIo6f);
        }
    } elseif ($_IjjLQ == 'content-id') {
        // sort for content-id
        if ($GLOBALS["_I0l11"]['NaturalOrder']) {
            natcasesort($_IIo6f);
        } else {
            asort($_IIo6f);
        }
    }

    foreach ($_IIo6f as $_QClCI => $_QC8li) {

        if (PMA_strlen($_QC8li) <= $GLOBALS["_I0l11"]['LimitChars']) {
            $_IjJlo = '';
            $_QC8li  = htmlspecialchars($_QC8li);
        } else {
            $_IjJlo  = htmlspecialchars($_QC8li);
            $_QC8li  = htmlspecialchars(substr($_QC8li, 0, $GLOBALS["_I0l11"]['LimitChars']) . '...');
        }

        $_Ij601 = '                <option value="' . htmlspecialchars($_QClCI) . '"';
        if ($_IjJlo != '') {
            $_Ij601 .= ' title="' . $_IjJlo . '"';
        }

        if ((string) $_QClCI == (string) $_Ijjt6) {
           $_Ij601 .= ' selected="selected"';
        }

        if ($_IjjLQ == 'content-id') {
            $_IjJIj[] = $_Ij601 . '>' . $_QC8li . '&nbsp;-&nbsp;' . htmlspecialchars($_QClCI) .  '</option>' . "\n";
        } else {
            $_IjJIj[] = $_Ij601 . '>' . htmlspecialchars($_QClCI) .  '&nbsp;-&nbsp;' . $_QC8li . '</option>' . "\n";
        }
    } // end foreach

    return $_IjJIj;
} // end of 'PMA__foreignDropdownBuild' function

/**
 * Outputs dropdown with values of foreign fields
 *
 * @uses    $_I0l11['ForeignKeyMaxLimit']
 * @uses    $_I0l11['ForeignKeyDropdownOrder']
 * @uses    _QL0PA()
 * @uses    PMA_isValid()
 * @uses    implode()
 * @param   array    array of the displayed row
 * @param   string   the foreign field
 * @param   string   the foreign field to display
 * @param   string   the current data of the dropdown (field in row)
 * @return  string   the <option value=""><option>s
 * @access  public
 */
function _QL1OP($_Ij6oI, $_Ij6oj, $_IjfJC, $_Ijjt6,
    $_Ij8IQ = null)
{
    if (null === $_Ij8IQ) {
        $_Ij8IQ = $GLOBALS["_I0l11"]['ForeignKeyMaxLimit'];
    }

    $_IIo6f = array();

    // collect the data
    foreach ($_Ij6oI as $_Ij8oQ) {
        $_QClCI   = $_Ij8oQ[$_Ij6oj];

        // if the display field has been defined for this foreign table
        if ($_IjfJC) {
            $_QC8li  = $_Ij8oQ[$_IjfJC];
        } else {
            $_QC8li = '';
        } // end if ($_IjfJC)

        $_IIo6f[$_QClCI] = $_QC8li;
    } // end foreach

    // put the dropdown sections in correct order
    $_QOo80 = array();
    $_IjtQ0 = array();
    if (PMA_isValid($GLOBALS["_I0l11"]['ForeignKeyDropdownOrder'], 'array')) {
        if (PMA_isValid($GLOBALS["_I0l11"]['ForeignKeyDropdownOrder'][0])) {
            $_QOo80 = _QL0PA($_IIo6f, $_Ijjt6,
                $GLOBALS["_I0l11"]['ForeignKeyDropdownOrder'][0]);
        }
        if (PMA_isValid($GLOBALS["_I0l11"]['ForeignKeyDropdownOrder'][1])) {
            $_IjtQ0 = _QL0PA($_IIo6f, $_Ijjt6,
                $GLOBALS["_I0l11"]['ForeignKeyDropdownOrder'][1]);
        }
    } else {
        $_QOo80 = _QL0PA($_IIo6f, $_Ijjt6, 'id-content');
        $_IjtQ0 = _QL0PA($_IIo6f, $_Ijjt6, 'content-id');
    }

    // beginning of dropdown
    $_IjtlL = '<option value="">&nbsp;</option>' . "\n";

    $_IjOfi = count($_QOo80);
    if ($_Ij8IQ == -1 || $_IjOfi < $_Ij8IQ) {
        $_IjtlL .= implode('', $_QOo80);
        if ($_IjOfi > 0) {
            $_IjtlL .= '                <option value="">&nbsp;</option>' . "\n";
            $_IjtlL .= '                <option value="">&nbsp;</option>' . "\n";
        }
    }
    $_IjtlL .= implode('', $_IjtQ0);

    return $_IjtlL;
} // end of '_QL1OP()' function

/**
 * Gets foreign keys in preparation for a drop-down selector
 * Thanks to <markus@noga.de>
 *
 * @uses    PMA_Table::countRecords()
 * @uses    PMA_backquote()
 * @uses    _QOCRC()
 * @uses    PMA_sqlAddslashes()
 * @uses    PMA_DBI_fetch_value()
 * @uses    PMA_DBI_free_result()
 * @uses    PMA_DBI_query()
 * @uses    PMA_DBI_num_rows()
 * @uses    PMA_DBI_fetch_assoc()
 * @param   array    array of the foreign keys
 * @param   string   the foreign field name
 * @param   bool     whether to override the total
 * @param   string   a possible filter
 * @param   string   a possible LIMIT clause
 * @return  array    data about the foreign keys
 * @access  public
 */

function _QL1FB($_IjoIQ, $_Qo0Jl, $_IjC0o, $_IjCOQ, $_IjCL6)
{
    // we always show the foreign field in the drop-down; if a display
    // field is defined, we show it besides the foreign field
    $_IjiJj = false;
    if ($_IjoIQ && isset($_IjoIQ[$_Qo0Jl])) {
        $_IjiOf       = $_IjoIQ[$_Qo0Jl];
        $_IjLjL      = $_IjiOf['foreign_db'];
        $_IjLLo   = $_IjiOf['foreign_table'];
        $_Ij6oj   = $_IjiOf['foreign_field'];

        // Count number of rows in the foreign table. Currently we do
        // not use a drop-down if more than 200 rows in the foreign table,
        // for speed reasons and because we need a better interface for this.
        //
        // We could also do the SELECT anyway, with a LIMIT, and ensure that
        // the current value of the field is one of the choices.

        $_IjljQ   = PMA_Table::countRecords($_IjLjL, $_IjLLo);

        if ($_IjC0o == true || $_IjljQ < $GLOBALS["_I0l11"]['ForeignKeyMaxLimit']) {
            // foreign_display can be FALSE if no display field defined:
            $_IjfJC = _QOCRC($_IjLjL, $_IjLLo);

            $_IjlCl = 'SELECT ' . PMA_backquote($_Ij6oj)
                        . (($_IjfJC == FALSE) ? '' : ', ' . PMA_backquote($_IjfJC));
            $_IJ0OQ = ' FROM ' . PMA_backquote($_IjLjL) . '.' . PMA_backquote($_IjLLo);
            $_IJ1QC = empty($_IjCOQ) ? '' : ' WHERE ' . PMA_backquote($_Ij6oj)
                            . ' LIKE "%' . PMA_sqlAddslashes($_IjCOQ, TRUE) . '%"'
                            . (($_IjfJC == FALSE) ? '' : ' OR ' . PMA_backquote($_IjfJC)
                                . ' LIKE "%' . PMA_sqlAddslashes($_IjCOQ, TRUE) . '%"'
                                );
            $_IJQ1L = ($_IjfJC == FALSE) ? '' :' ORDER BY ' . PMA_backquote($_IjLLo) . '.' . PMA_backquote($_IjfJC);
            $_IJQo6 = isset($_IjCL6) ? $_IjCL6 : '';

            if (!empty($_IjCOQ)) {
                $_IJIJ8 = PMA_DBI_query('SELECT COUNT(*)' . $_IJ0OQ . $_IJ1QC);
                if ($_IJIJ8) {
                    $_IjljQ = PMA_DBI_fetch_value($_IJIJ8);
                    @PMA_DBI_free_result($_IJIJ8);
                } else {
                    $_IjljQ = 0;
                }
            }

            $_IJIli  = PMA_DBI_query($_IjlCl . $_IJ0OQ . $_IJ1QC . $_IJQ1L . $_IJQo6);
            if ($_IJIli && PMA_DBI_num_rows($_IJIli) > 0) {
                // If a resultset has been created, pre-cache it in the $_Ij6oI array
                // This helps us from not needing to use mysql_data_seek by accessing a pre-cached
                // PHP array. Usually those resultsets are not that big, so a performance hit should
                // not be expected.
                $_Ij6oI = array();
                while ($_IJjoC = @PMA_DBI_fetch_assoc($_IJIli)) {
                    $_Ij6oI[] = $_IJjoC;
                }
                @PMA_DBI_free_result($_IJIli);
            }
        } else {
            $_Ij6oI = null;
            $_IjiJj = true;
        }
    }  // end if $_IjoIQ

    $_IJjCO['foreign_link'] = $_IjiJj;
    $_IJjCO['the_total'] = isset($_IjljQ) ? $_IjljQ : null;
    $_IJjCO['foreign_display'] = isset($_IjfJC) ? $_IjfJC : null;
    $_IJjCO['disp_row'] = isset($_Ij6oI) ? $_Ij6oI : null;
    $_IJjCO['foreign_field'] = isset($_Ij6oj) ? $_Ij6oj : null;
    return $_IJjCO;
} // end of '_QL1FB()' function

/**
 * Finds all related tables
 *
 * @uses    $GLOBALS["_IQt1I"]
 * @uses    $GLOBALS["_IQijI"]
 * @uses    $GLOBALS["_I1too"]
 * @param   string   whether to go from master to foreign or vice versa
 * @return  boolean  always TRUE
 * @global  array    $_IJJlo the list of tables that we still couldn't connect
 * @global  array    $_IJ6tC the list of allready connected tables
 * @global  string   $_IJfQI
 *
 * @access  private
 */
function _QLQ6C($_IJJjo)
{
    global $_IJJlo, $_IJ6tC, $_IJfQI;

    if ($_IJJjo == 'master') {
        $_IJfjJ    = 'foreign';
    } else {
        $_IJfjJ    = 'master';
    }
    $_IJfCJ = '(\'' . implode('\', \'', $_IJ6tC) . '\')';
    $_IJfLQ = '(\'' . implode('\', \'', $_IJJlo) . '\')';

    $_IIotl = 'SELECT *'
               . '  FROM ' . PMA_backquote($GLOBALS["_IQijI"]['db'])
               .       '.' . PMA_backquote($GLOBALS["_IQijI"]['relation'])
               . ' WHERE ' . $_IJJjo . '_db = \'' . PMA_sqlAddslashes($GLOBALS["_I1too"]) . '\''
               . '   AND ' . $_IJfjJ   . '_db = \'' . PMA_sqlAddslashes($GLOBALS["_I1too"]) . '\''
               . '   AND ' . $_IJJjo . '_table IN ' . $_IJfCJ
               . '   AND ' . $_IJfjJ   . '_table IN ' . $_IJfLQ;
    $_IILLi = @PMA_DBI_query($_IIotl, $GLOBALS["_IQt1I"]);
    while ($_QOJCl = PMA_DBI_fetch_assoc($_IILLi)) {
        $_IJ8Io                = $_QOJCl[$_IJfjJ . '_table'];
        if (isset($_IJJlo[$_IJ8Io])) {
            $_IJfQI
                .= "\n" . ' LEFT JOIN '
                . PMA_backquote($GLOBALS["_I1too"]) . '.' . PMA_backquote($_QOJCl[$_IJfjJ . '_table']) . ' ON '
                . PMA_backquote($_QOJCl[$_IJJjo . '_table']) . '.'
                . PMA_backquote($_QOJCl[$_IJJjo . '_field']) . ' = '
                . PMA_backquote($_QOJCl[$_IJfjJ . '_table']) . '.'
                . PMA_backquote($_QOJCl[$_IJfjJ . '_field']) . ' ';
            $_IJ6tC[$_IJ8Io] = $_IJ8Io;
            unset($_IJJlo[$_IJ8Io]);
        }
    } // end while

    return true;
} // end of the "_QLQ6C()" function

/**
 * Rename a field in relation tables
 *
 * usually called after a field in a table was renamed in tbl_alter.php
 *
 * @uses    _QO8P6()
 * @uses    PMA_backquote()
 * @uses    PMA_sqlAddslashes()
 * @uses    _QO86Q()
 * @param string $_I1too
 * @param string $_QtoOL
 * @param string $_Qo0Jl
 * @param string $_IJ8OQ
 */
function _QLQAE($_I1too, $_QtoOL, $_Qo0Jl, $_IJ8OQ)
{
    $_IQijI = _QO8P6();

    if ($_IQijI['displaywork']) {
        $_IJt10 = 'UPDATE ' . PMA_backquote($_IQijI['db']) . '.' . PMA_backquote($_IQijI['table_info'])
                      . '   SET display_field = \'' . PMA_sqlAddslashes($_IJ8OQ) . '\''
                      . ' WHERE db_name       = \'' . PMA_sqlAddslashes($_I1too) . '\''
                      . '   AND table_name    = \'' . PMA_sqlAddslashes($_QtoOL) . '\''
                      . '   AND display_field = \'' . PMA_sqlAddslashes($_Qo0Jl) . '\'';
        _QO86Q($_IJt10);
    }

    if ($_IQijI['relwork']) {
        $_IJt10 = 'UPDATE ' . PMA_backquote($_IQijI['db']) . '.' . PMA_backquote($_IQijI['relation'])
                      . '   SET master_field = \'' . PMA_sqlAddslashes($_IJ8OQ) . '\''
                      . ' WHERE master_db    = \'' . PMA_sqlAddslashes($_I1too) . '\''
                      . '   AND master_table = \'' . PMA_sqlAddslashes($_QtoOL) . '\''
                      . '   AND master_field = \'' . PMA_sqlAddslashes($_Qo0Jl) . '\'';
        _QO86Q($_IJt10);

        $_IJt10 = 'UPDATE ' . PMA_backquote($_IQijI['db']) . '.' . PMA_backquote($_IQijI['relation'])
                      . '   SET foreign_field = \'' . PMA_sqlAddslashes($_IJ8OQ) . '\''
                      . ' WHERE foreign_db    = \'' . PMA_sqlAddslashes($_I1too) . '\''
                      . '   AND foreign_table = \'' . PMA_sqlAddslashes($_QtoOL) . '\''
                      . '   AND foreign_field = \'' . PMA_sqlAddslashes($_Qo0Jl) . '\'';
        _QO86Q($_IJt10);
    } // end if relwork
}

/**
 * Create a PDF page
 *
 * @uses    $GLOBALS["_IJOti"]
 * @uses    PMA_backquote()
 * @uses    $GLOBALS["_IQijI"]['db']
 * @uses    PMA_sqlAddslashes()
 * @uses    _QO86Q()
 * @uses    PMA_DBI_insert_id()
 * @uses    $GLOBALS["_IQt1I"]
 * @param string    $_IJt6O
 * @param array     $_IQijI
 * @param string    $_I1too
 * @param string    $_IJOJj
 * @return string   $pdf_page_number
 */
function _QLQDF($_IJt6O, $_IQijI, $_I1too, $_IJOJj) {
    if (! isset($_IJt6O) || $_IJt6O == '') {
        $_IJt6O = $GLOBALS["_IJOti"];
    }
    $_IJo6f   = 'INSERT INTO ' . PMA_backquote($GLOBALS["_IQijI"]['db']) . '.' . PMA_backquote($_IQijI['pdf_pages'])
                 . ' (db_name, page_descr)'
                 . ' VALUES (\'' . PMA_sqlAddslashes($_I1too) . '\', \'' . PMA_sqlAddslashes($_IJt6O) . '\')';
    _QO86Q($_IJo6f, FALSE, $_IJOJj);
    return PMA_DBI_insert_id(isset($GLOBALS["_IQt1I"]) ? $GLOBALS["_IQt1I"] : '');
}
?>
